LeetCode||1.Two Sum

1. Two Sum

  • Total Accepted: 317935
  • Total Submissions: 1163044
  • Difficulty: Easy

Given an array of integers, return indices of the two numbers such that they add up to a specific target.

You may assume that each input would have exactly one solution.

Example:

Given nums = [2, 7, 11, 15], target = 9,

Because nums[0] + nums[1] = 2 + 7 = 9,
return [0, 1].
看到这题我一开始想用for循环嵌套的,然而,超时了……

O(n^2)的时间复杂度看样子是不被允许的,那只能优化了,然后我找了找其它人的写法,很有意思,用hashtable,我怎么就没想到,Java里面超多API,我竟然没用。

如题,这里只有两个数符合,所以不要想复杂了。

附上代码

import java.util.Hashtable;
public class Solution {
    public int[] twoSum(int[] nums, int target) {
        int a[] = new int[2];
		Hashtable<Integer, Integer> numbers = new Hashtable<Integer,Integer>();
		for (int i = 0; i < nums.length; i++) {
			Integer n = numbers.get(nums[i]);
			if (n==null) {
				numbers.put(nums[i], i);
			}
			n = numbers.get(target-nums[i]);
			if (n!=null&&n<i) {
				a[0]=n;
				a[1]=i;
				return a;
			}
		}
        return a;
    }
}


评论
添加红包

请填写红包祝福语或标题

红包个数最小为10个

红包金额最低5元

当前余额3.43前往充值 >
需支付:10.00
成就一亿技术人!
领取后你会自动成为博主和红包主的粉丝 规则
hope_wisdom
发出的红包
实付
使用余额支付
点击重新获取
扫码支付
钱包余额 0

抵扣说明:

1.余额是钱包充值的虚拟货币,按照1:1的比例进行支付金额的抵扣。
2.余额无法直接购买下载,可以购买VIP、付费专栏及课程。

余额充值